extends KinematicBody


export var move_speed = 750

export var gravity = 3000
export var jump_force = 1300
export var max_fall_speed = 3000

var y_velo = 0

var snap_normal = Vector3.DOWN

func movement(delta):
	var move_vec = Vector3()
	if Input.is_action_pressed("move_left"):
		move_vec.x -= 1
	if Input.is_action_pressed("move_right"):
		move_vec.x += 1
	move_vec *= move_speed
	move_vec.y = y_velo
	move_and_slide_with_snap(move_vec * delta, snap_normal, Vector3.UP)
	
	var grounded = is_on_floor()
	y_velo -= gravity * delta

	if grounded:
		if Input.is_action_pressed("jump"):
			set_snap_normal(Vector3(0,0,0))
			y_velo = jump_force
		if y_velo <= 0:
			set_snap_normal(Vector3.DOWN)

func set_snap_normal(new_snap_normal):
	snap_normal = new_snap_normal

func _physics_process(delta):
	movement(delta)
